#include <malloc.h>

#include "sched.h"

int              classcount, profcount, roomcount, exclusionpaircount;
int              studentcount;
int              exclcost,  profcost, spacingcost, student_choice_cost;
double           rmsizecost, cost, mincost = 10000.0;
double           rcost, rnewcost, dcost, cost_1, cost_2, cost_3, cost_4;
double           s_cost_old, h_cost_old, h_cost_new, h_cost_old;
int              iters_per_timestep, timesteps, ann_timestep;
double           cooling_factor, temperature, exp_value, boltzmann_value;
double           pow();

STUDENT          *students;
PROFESSOR        *professors;
CLASS            *classes, *saveclasses;
ROOM             *rooms;
 
int              *times;
int              exclusionpairs[MAXEXCLUSIONPAIRS][2];

int              state[MAXNUMBLD];
char             building[MAXNUMBLD][STRLENGTH];
char             dept[MAXNUMDEPT][STRLENGTH];
int              real_distance[MAXNUMBLD][MAXNUMBLD];
int              state_distance[MAXNUMDEPT][MAXNUMBLD];
int              home_building[MAXNUMDEPT];


void main()
{
  printf("\n\n ********************** begin ******************\n");

  if ((times = (int *) malloc(TIMESLOTS * sizeof(int))) == NULL)
    {
      fprintf(stderr,"No available memory for array %s. \n","times");
      exit(1);
    }

  read_matrices_and_create_distance();  

  load_data();

  printf("\n\nRoomcount: %d\t Profcount: %d\t Classcount: %d\t Studentcount: %d\n\n", roomcount, profcount, classcount, studentcount);


  randomly_initialize_schedule();

  printf("\n====================schedule after initialization==================\n");
  write_schedule(); 
  anneal_on_time_room();
  printf("\n\n=========== anneal on TIME and SPACE =================\n\n");
  printf("\n\nCost: %f ExclCost: %f RmSizeCost: %f\n ProfCost: %f SpacingCost: %f  MinCost: %f\n\n",  cost, cost_1, rmsizecost, cost_2, cost_3, mincost);
  fflush(stdout);
  write_schedule();   
  fflush(stdout);
}

/***======================================================***/
/***======================================================***/
/***======================================================***/


int read_matrices_and_create_distances(void)
{
        FILE    *fptr1, *fptr2;
        char    tmpdept[STRLENGTH],  tmpbuilding[STRLENGTH];
        int     j = 0; 
	int     i = 0;

        if ((fptr2 = fopen("distances.dat","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n","distances.dat");
           exit(1);
         }

        fscanf(fptr2,
        "%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s\n", 
               building[0], building[1], building[2], building[3], building[4], building[5], 
               building[6], building[7], building[8], building[9], building[10], building[11], 
               building[12], building[13], building[14], building[15], building[16], building[17], 
               building[18], building[19], building[20], building[21], building[22], building[23], 
               building[24], building[25], building[26], building[27], building[28], building[29], 
               building[30], building[31], building[32], building[33], building[34], building[35], 
               building[36], building[37], building[38], building[39], building[40], building[41]);
        while (fscanf(fptr2,
         "%s %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",
         tmpbuilding, 
         &(real_distance[j][0]), &(real_distance[j][1]), &(real_distance[j][2]),
         &(real_distance[j][3]), &(real_distance[j][4]), &(real_distance[j][5]), 
         &(real_distance[j][6]), &(real_distance[j][7]), &(real_distance[j][8]), 
         &(real_distance[j][9]), &(real_distance[j][10]), &(real_distance[j][11]),
         &(real_distance[j][12]), &(real_distance[j][13]), &(real_distance[j][14]),
         &(real_distance[j][15]), &(real_distance[j][16]), &(real_distance[j][17]), 
         &(real_distance[j][18]), &(real_distance[j][19]), &(real_distance[j][20]), 
         &(real_distance[j][21]), &(real_distance[j][22]), &(real_distance[j][23]), 
         &(real_distance[j][24]), &(real_distance[j][25]), &(real_distance[j][26]), 
         &(real_distance[j][27]), &(real_distance[j][28]), &(real_distance[j][29]), 
         &(real_distance[j][30]), &(real_distance[j][31]), &(real_distance[j][32]), 
         &(real_distance[j][33]), &(real_distance[j][34]), &(real_distance[j][35]), 
         &(real_distance[j][36]), &(real_distance[j][37]), &(real_distance[j][38]), 
	 &(real_distance[j][39]), &(real_distance[j][40]), &(real_distance[j][41])) != EOF) {
          j++;
        }
        fclose(fptr2);

        if ((fptr1 = fopen("states.dat","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n","states.dat");
           exit(1);
         }              
        fscanf(fptr1,
        "%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s\n", 
               building[0], building[1], building[2], building[3], building[4], building[5], 
               building[6], building[7], building[8], building[9], building[10], building[11], 
               building[12], building[13], building[14], building[15], building[16], building[17], 
               building[18], building[19], building[20], building[21], building[22], building[23], 
               building[24], building[25], building[26], building[27], building[28], building[29], 
               building[30], building[31], building[32], building[33], building[34], building[35], 
               building[36], building[37], building[38], building[39], building[40], building[41]);

        j = 0;

        while (
        fscanf(fptr1,
        "%s %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",
               tmpdept, &state[0], &state[1], &state[2], &state[3], &state[4], &state[5], 
               &state[6], &state[7], &state[8], &state[9], &state[10], &state[11], &state[12], 
               &state[13], &state[14], &state[15], &state[16], &state[17], &state[18], 
               &state[19], &state[20], &state[21], &state[22], &state[23], &state[24], 
               &state[25], &state[26], &state[27], &state[28], &state[29], &state[30], 
               &state[31], &state[32], &state[33], &state[34], &state[35], &state[36], 
               &state[37], &state[38], &state[39], &state[40], &state[41]) != EOF) {
          strcpy(dept[j], tmpdept);
          for (i=0; i < MAXNUMBLD; i++)
            {
              if (state[i] == 1)
                home_building[j] = i;
            }
          for (i=0; i < MAXNUMBLD; i++)
            {
              if (state[i] == 0)
                {
                  state_distance[j][i] = 99999;
                }
              else
                {
                  if (state[i] == 1)
                    {
                      state_distance[j][i] = 1;
                    }
                  else
                    {
                      state_distance[j][i] = real_distance[home_building[j]][i];
                    }
                }
            }
          j++;
        }
        fclose(fptr1);
      }

/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/

load_data()
{
	FILE           *fptr;

	char            tmpchar[STRINGLENGTH], prefixchar[3];
        char            tmpchar6[FIELDLENGTH];  /* used to read names... */

	int             tmpint, tmpint4, tmpint5, 
                        tmpint6, tmpint7, i ;
	int             tmpint_1, tmpint_2, tmpint_3, tmpint_4, tmpint_5, 
	                tmpint_6, tmpint_7, tmpint_8, tmpint_9, tmpint_10;
        int             tmpint_0, tmpint_11, tmpint_12, tmpint_13;

	int             tmpint1, tmpint2, tmpint3;
	char            tmpchar1[BLD_NAME_LEN], tmpchar2[ROOM_NUM_LEN], 
		        tmpchar3[ROOM_TYPE_LEN], tmpchar4[ROOM_PURPOSE_LEN], 
	                tmpchar5[ROOM_PRIORTIES_LEN]; 
        
        srandom(time(NULL));

        if ((saveclasses = (CLASS *) malloc(sizeof(CLASS))) == NULL)
	  {
           fprintf(stderr,"Can NOT allocate memory for %s  - bye!\n","saveclasses");
           exit(1);
	 }
	if ((rooms = (ROOM *) malloc(PHYSICALROOMS * sizeof(ROOM))) == NULL)
          {
           fprintf(stderr,"Can NOT allocate memory for %s - bye!\n","rooms");
           exit(1);
	 }
	if ((professors = (PROFESSOR *) malloc(MAXNUMPROFS * sizeof(PROFESSOR))) == NULL)
          {
           fprintf(stderr,"Can NOT allocate memory for %s - bye!\n","professors");
           exit(1);
	 }
	if ((classes = (CLASS *) malloc(MAXNUMCLASSES * sizeof(CLASS))) == NULL)
          {
           fprintf(stderr,"Can NOT allocate memory for %s - bye!\n","classes");
           exit(1);
	 }
	if ((students = (STUDENT *) malloc(MAXNUMSTUDENTS * sizeof(STUDENT))) == NULL)
          {
           fprintf(stderr,"Can NOT allocate memory for %s - bye!\n","students");
           exit(1);
	 }
/*----------(1)------------------------------------------------------*/	
/* Read students records from File.                                  */
/* name, ssn, major, numb of classes,  choice classes.               */
/*-------------------------------------------------------------------*/
        studentcount = i = 0;
	if ((fptr = fopen("STUDENTS.data","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n","STUDENTS.data");
           exit(1);
         }              
	while (fscanf(fptr,"%s %ld %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
		      tmpchar6, &tmpint1, &tmpint2, &tmpint3,
		      &tmpint_0, &tmpint_1, &tmpint_2, &tmpint_3,
                      &tmpint_4, &tmpint_5, &tmpint_6, &tmpint_7,
                      &tmpint_8, &tmpint_9, &tmpint_10, &tmpint_11,
                      &tmpint_12, &tmpint_13) != EOF)
	  { 
	  strcpy(students[i].name, tmpchar6);
          students[i].studentid = tmpint1;
	  students[i].major= tmpint2;
          students[i].numb_classes_chosen=tmpint3;
	  students[i].first_choice[0]= tmpint_0;
	  students[i].first_choice[1]= tmpint_1;
	  students[i].first_choice[2]= tmpint_2;
	  students[i].first_choice[3]= tmpint_3;
	  students[i].first_choice[4]= tmpint_4;
	  students[i].first_choice[5]= tmpint_5;
	  students[i].first_choice[6]= tmpint_6;
	  students[i].first_choice[7]= tmpint_7;
	  students[i].first_choice[8]= tmpint_8;
	  students[i].first_choice[9]= tmpint_9;
	  students[i].first_choice[10]= tmpint_10;
	  students[i].first_choice[11]= tmpint_11;
	  students[i].first_choice[12]= tmpint_12;
	  students[i].first_choice[13]= tmpint_13;
          i++;
	}
	fclose(fptr);
        studentcount = i;

/*-----------------(2)---------------------*/
/* Read Class Numbers And Names from File  */
/* class number, class name (or prefix).   */
/*-----------------------------------------*/
        classcount = i = 0;
	if ((fptr = fopen("CLASSES.data","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n","CLASSES.data");
           exit(1);
         }              
	while (fscanf(fptr, "%d  %s  %s", &tmpint, tmpchar, prefixchar) != EOF) {
	  strcpy(classes[i].name, tmpchar);
	  strcpy(classes[i].prefix, prefixchar);
	  classes[i].number = tmpint;
	  i++;
	}
	fclose(fptr);
        classcount = i;
/*-------------(3)----------------------------*/
/* Read Professor Numbers and Names from File */
/* prof number, prof name.                    */
/*--------------------------------------------*/

	profcount = i = 0;
	if ((fptr = fopen("PROFESSORS.data","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n","PROFESSORS.data");
           exit(1);
         }              

/* tmpint: is the professor number 
   (assuming it is in a sequential order). 
   tmpchar: professor name. Here, also we will assume that
   number of classes taught by the professor is initialized
   to zero. */

	while (fscanf(fptr, "%d  %s", &tmpint, tmpchar) != EOF) {
	  strcpy(professors[i].name, tmpchar);
	  professors[i].nclasses = 0;
	  professors[i].number = tmpint;
	  i++;
	}
	fclose(fptr);
        profcount = i;
/*-----------(4)--------------------*/
/* Read Class Enrollments from File */
/* class number, enrollments size.  */
/*----------------------------------*/
	i = 0;

/* tmpint1: the class number (sequentially).           */
/* tmpint2: the size of that class.                    */

	if ((fptr = fopen("ENROLLMENT.data","r")) == NULL)
	  {
	    fprintf(stderr,"Cannot open %s  - bye!\n","ENROLLMENT.data");
	    exit(1);
	  }              
	while (fscanf(fptr, "%d   %d   %d", &tmpint1, &tmpint2, &tmpint3) != EOF) 
	  {
	    classes[i].number = tmpint1;
	    if (tmpint3 == 0)
	      {
		classes[classes[i].number].enrollment = (random() % 10) + 5;
	      }
	    else
	      classes[classes[i].number].enrollment = tmpint3;
	    classes[i].maxenrollment = tmpint3;

#if 0
printf("class(i) : %d, or class(tmpint1) : %d  has an enrollment of tmpint2 : %d\n", i, tmpint1, classes[i].enrollment);
#endif
	    i++;
	  }
	fclose(fptr);

/*------------------(5)-------------------------*/
/* Read Professor/Class Assignments from File   */
/* class number, the assigned professor number. */
/*----------------------------------------------*/
/* tmpint: the class number (sequentially). tmpint2:
   number of the professor assigned to the given
   class. */

        i = 0;
	if ((fptr = fopen("CLASS_PROF.data","r")) == NULL)
	  {
	    fprintf(stderr,"Cannot open %s  - bye!\n","CLASS_PROF.data");
	    exit(1);
	  }              
	while (fscanf(fptr, "%d %d", &tmpint1, &tmpint2) != EOF) 
	  {
	    classes[i].profnumber = tmpint2;
	    professors[tmpint2].classnumbers[professors[tmpint2].nclasses]
	      = tmpint1;
	    professors[tmpint2].nclasses++;
	    i++;
	  }
	fclose(fptr);

/*----------------------(6)--------------------------------------------*/
/* Read Classroom Attributes from File                                 */
/* room number, capacity, presence of AV equipments (5 types).         */
/*---------------------------------------------------------------------*/
	roomcount = i = 0;
	if ((fptr = fopen("ROOMS.data","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n","ROOMS.data");
           exit(1);
         }              
	while (fscanf(fptr, "%d %s %s %d %s %s %s", 
		      &tmpint1, tmpchar1, tmpchar2, &tmpint2, 
		      tmpchar3, tmpchar4, tmpchar5) != EOF) {    
	  rooms[i].room_tag = tmpint1;
	  strcpy(rooms[i].bldg, tmpchar1);
	  strcpy(rooms[i].room_num, tmpchar2);
	  rooms[i].room_capacity = tmpint2;
	  strcpy(rooms[i].room_type, tmpchar3);
	  strcpy(rooms[i].room_purpose, tmpchar4);
	  strcpy(rooms[i].room_priority, tmpchar5);
	  rooms[i].nclasses = 0;
	  i++;
	}
	fclose(fptr);
	roomcount = i;

/*------------------------(7)------------------------------------*/
/* Read Class pairs that can't happen at same time               */
/* class number (sequential tag), class number (sequential tag). */
/*---------------------------------------------------------------*/

	exclusionpaircount = i = 0;
	if ((fptr = fopen("EXECLUSIVE.data","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n","EXECLUSIVE.data");
           exit(1);
         }              
	while (fscanf(fptr, "%d %d", exclusionpairs[i], exclusionpairs[i] + 1) != EOF) {
		exclusionpaircount++;
		i++;
	}
	fclose(fptr);
/*-----------------------------(8)-------------------------------------*/
/* read annealing parameters                                           */
/* cooling factor, temp, iter_per_timestep, exp_value, boltzman_value. */
/*---------------------------------------------------------------------*/

	if ((fptr = fopen("parameters.dat","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n","parameters.dat");
           exit(1);
         }              
	fscanf(fptr, "%lf ", &cooling_factor);
	fscanf(fptr, "%lf ", &temperature);
	fscanf(fptr, "%d ",  &iters_per_timestep);
	fscanf(fptr, "%d ",  &timesteps);
	fscanf(fptr, "%lf ", &exp_value);
	fscanf(fptr, "%lf ", &boltzmann_value);
	fclose(fptr);
}

/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/

randomly_initialize_schedule()
{
	int             i = 0;

        srandom(time(NULL));

	for (i = 0; i < classcount; i++) {
	  classes[i].rmcost = 1.0;
	  classes[i].time = (random() % TIMESLOTS);
	  classes[i].room = (random() % PHYSICALROOMS);
	  classes[i].troom = 100 * classes[i].room + classes[i].time;
	  rooms[classes[i].room].nclasses++;
	}
      }

/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/

energy_type * cost_fn()
{
	int             i, j, k, c1, c2;
	int             max, min;
	energy_type     *energy_cost;

	exclcost = 0;
	rmsizecost = 0.0;
	profcost = 0;
	spacingcost = 0;
	student_choice_cost = 0;
	cost_1 = cost_2 = cost_3 = cost_4 = 0.0;

/* -------------(1) --Class Exclusion Pairs------------- */

#if 0
	for (i = 0; i < exclusionpaircount; i++) {
		c1 = exclusionpairs[i][0];
		c2 = exclusionpairs[i][1];
		if (classes[c1].time == classes[c2].time)
			exclcost++;    /* if the class-pair takes place at the
                                          same time, then cost will incur. 
                                          (timeconflict-cost) */
	}
	cost_1 = (double) exclcost;

#endif

/*--------------------------------------------------------*/
/*------------------- room size cost --------------------*/
	for (i = 0; i < classcount; i++) 
	  {
	    if (classes[i].enrollment > rooms[classes[i].room].room_capacity)
	      {
		classes[i].rmcost = 1.0;
	      }
	    else
	      {
                classes[i].rmcost = 
		  (tanh(sinh((1.0 - ((double) classes[i].enrollment / rooms[classes[i].room].room_capacity) - 0.5) * 0.8 * PI)) + 1.0) / 2.0;
	      }
            rmsizecost += classes[i].rmcost;
	  }
#if 0
	fprintf(fptr2," rmsizecost = %f \n", rmsizecost);
#endif

/*--------------------------------------------------------*/
/*------------------professor cost------------------------*/

#if 0
	for (i = 0; i < profcount; i++) {
	  for (j = 0; j < professors[i].nclasses; j++) {
	    for (k = j + 1; k < professors[i].nclasses; k++) {
	      if (classes[professors[i].classnumbers[j]].time ==
		  classes[professors[i].classnumbers[k]].time)
		profcost++;
	    }
	  }
	}
	cost_2 = (double) profcost;
#endif
	

/*-----------------students cost----------------------------*/
/*----- Cost incured from each student class times: if at a single time
        the student has more than one class, then a cost will be
        calculated. ------------------------------------------------*/

#if 0
	for (i=0; i < studentcount; i++)
	  {
	    for (j=0; j < students[i].numb_classes_chosen; j++)
	      {
		for (k=j+1; k < students[i].numb_classes_chosen; k++)
		  {
		    if ((students[i].first_choice[j] != -1) && 
			(students[i].first_choice[j] != -2) && 
			(students[i].first_choice[k] != -1) &&
			(students[i].first_choice[k] != -2) &&)
		      {
			if (classes[students[i].first_choice[j]].time ==
			    classes[students[i].first_choice[k]].time)
			  student_choice_cost++;
		      }
		  }
	      }
	  }
	cost_4 = (double) student_choice_cost;
#endif

/*---- Overall Class Schedule Time Spacing -------------------------*/

#if 0
	for (i = 0; i < TIMESLOTS; i++)
	  times[i] = 0;
	for (i = 0; i < classcount; i++) 
	  times[classes[i].time]++;

/*----(4) -- cost incurred from spacing between various time-slots -*/
/*------ (Soft Constraint): low priority ---------------------------*/

	max = 0;
	min = 100000;	       
	for (i = 0; i < TIMESLOTS; i++) {
	  if (times[i] > max)
	    max = times[i];
	  if (times[i] < min)
	    min = times[i];
	}
	spacingcost = (max - min);

/*  fprintf(fptr2," class spacingcost = %d \n\n", spacingcost);  */

        if (spacingcost==1) 
	  spacingcost = 0;
	cost_3 = (double) spacingcost;
#endif

	energy_cost = (energy_type *) malloc(sizeof(energy_type));


#if 0
	energy_cost->total_cost = 
	  400.0 * cost_1 + 350.0 * cost_2  + 250.0 * rmsizecost + 100.0 * cost_3 + 75.0 * cost_4;
#endif


	energy_cost->total_cost = rmsizecost;
	energy_cost->hard_cost = rmsizecost;
	energy_cost->soft_cost = 0.0;


#if 0
	energy_cost->hard_cost = 
	  400.0 * cost_1 + 350.0 * cost_2;
	energy_cost->soft_cost = 
	  250.0 * rmsizecost + 100.0 * cost_3 + 75.0 * cost_4;
#endif

        if (energy_cost->total_cost < mincost) 
	  mincost = energy_cost->total_cost;   /* For record keeping:  */

	return (energy_cost);
      }


/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/
/***---------------- For roomsize cost -----------------***/

void  delta_cost_fn(energy_type *energy_cost, int swap1, int swap2)
{
	int             i, j, k, c1, c2;
	int             max, min;

	exclcost = 0;
	profcost = 0;
	spacingcost = 0;
	student_choice_cost = 0;
	cost_1 = cost_2 = cost_3 = cost_4 = 0.0;

/* -------------(1) --Class Exclusion Pairs------------- */
#if 0
	for (i = 0; i < exclusionpaircount; i++) {
		c1 = exclusionpairs[i][0];
		c2 = exclusionpairs[i][1];
		if (classes[c1].time == classes[c2].time)
		  exclcost++;          /* if the class-pair takes place at the
                                          same time, then cost will incur. 
                                          (timeconflict-cost) */
	}
	cost_1 = (double) exclcost;
#endif

/*------------------------------------------------*/
        rmsizecost = energy_cost->total_cost;
#if 0
        printf("before rmsizecost = %g\n", rmsizecost);
        printf("before swap1 rmcost = %g\n", classes[swap1].rmcost);
        printf("before swap2 rmcost = %g\n", classes[swap2].rmcost);
#endif
	rmsizecost -= classes[swap1].rmcost;
	rmsizecost -= classes[swap2].rmcost;
	if (classes[swap1].enrollment > rooms[classes[swap1].room].room_capacity)
	  {
	    classes[swap1].rmcost = 1.0;
	  }
	else
	  {
	    classes[swap1].rmcost = 
	      (tanh(sinh((1.0 - ((double) classes[swap1].enrollment / rooms[classes[swap2].room].room_capacity) - 0.5) * 0.8 * PI)) + 1.0) / 2.0;
	  }

	if (classes[swap2].enrollment > rooms[classes[swap2].room].room_capacity)
	  {
	    classes[swap2].rmcost = 1.0;
	  }
	else
	  {
	    classes[swap2].rmcost = 
	      (tanh(sinh((1.0 - ((double) classes[swap2].enrollment / rooms[classes[swap1].room].room_capacity) - 0.5) * 0.8 * PI)) + 1.0) / 2.0;
	  }
	rmsizecost += classes[swap1].rmcost;
	rmsizecost += classes[swap2].rmcost;
#if 0
        printf("after rmsizecost = %g\n", rmsizecost);
        printf("after swap1 rmcost = %g\n", classes[swap1].rmcost);
        printf("after swap2 rmcost = %g\n", classes[swap2].rmcost);
#endif
/*-----------------------------------------------------*/
#if 0
	fprintf(fptr2,"delta_cost: rmsizecost = %f \n", rmsizecost);  

	for (i = 0; i < profcount; i++) {
	  for (j = 0; j < professors[i].nclasses; j++) {
	    for (k = j + 1; k < professors[i].nclasses; k++) {
	      if (classes[professors[i].classnumbers[j]].time ==
		  classes[professors[i].classnumbers[k]].time)
		profcost++;
	    }
	  }
	}
	cost_2 = (double) profcost;

	for (i=0; i < studentcount; i++)
	  {
	    for (j=0; j < students[i].numb_classes_chosen; j++)
	      {
		for (k=j+1; k < students[i].numb_classes_chosen; k++)
		  {
		    if (classes[students[i].first_choice[j]].time ==
			classes[students[i].first_choice[k]].time)
		      student_choice_cost++;
		  }
	      }
	  }
	cost_4 = (double) student_choice_cost;

	for (i = 0; i < TIMESLOTS; i++)
	  times[i] = 0;

	for (i = 0; i < classcount; i++) 
	  times[classes[i].time]++;

	max = 0;
	min = 100000;		
	for (i = 0; i < TIMESLOTS; i++) {
	  if (times[i] > max)
	    max = times[i];
	  if (times[i] < min)
	    min = times[i];
	}
	spacingcost = (max - min);

        if (spacingcost==1) 
	  spacingcost = 0;

	cost_3 = (double) spacingcost;
#endif
/*----------------------------------------------------------*/

	energy_cost->total_cost = rmsizecost;
	energy_cost->hard_cost = rmsizecost;
	energy_cost->soft_cost = 0.0;

        if (energy_cost->total_cost < mincost) 
	  mincost = energy_cost->total_cost;   /* For record keeping:  */

}

/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/
anneal_on_time_room()
{
        int             swap1 =0, swap2 = 0, j = 0, counter = 0,  i = 0;
        int             accept = FALSE;
        double          dice = 0.0, delta_cost = 0.0;
	energy_type     *cost_ptr;

        srandom(time(NULL));
	cost = 0.0;                   /* defined globally */
      
/*----------------------------------------------------------
    Let S = solution space. f = objective function. and N = set
    of neighborhood structures.
------------------------------------------------------------*/  
	cost_ptr = cost_fn();  
#if 1
        printf("initial-room-cost: %lf\n", cost_ptr->total_cost);
#endif
	for (ann_timestep = 0; ann_timestep < timesteps; ann_timestep++) 
	  {
	    for (j = 0; j < iters_per_timestep; j++) 
	      {

/*-------------------------------------------------------
   Note: this condition can act as a stopping criterion.
   when executed it will terminate the routine and
   return to the caller.
---------------------------------------------------------*/
		rcost = cost_ptr->total_cost;    
	                                        /* (1) compute the total cost of the 
						  current solution space S_0
						  = f(S_0) */
		if (rcost == 0.0)
		  {
		    printf("anneal_on_time_room(): timestep iteration = %d, time_step = %d\n",
			   j, ann_timestep);
		    return;  
		  }

		while (!accept)
		  {
		                                 /* (2) randomly select a new solution
						  space S_1 \in N, by doing a random
						  swapping of classes. */
		    swap1 = (random() % MAXNUMCLASSES);
		    do {
		      swap2 = (random() % MAXNUMCLASSES);
		    } while (swap1 == swap2);
		    check_the_corresponding_classes(accept, swap1, swap2); 
		  }

		delta_cost_fn(cost_ptr, swap1, swap2);  
		rnewcost = (double) cost_ptr->total_cost;   /* (3) compute the total cost of the
							  current solution space S_1 
							  = f(S_1) */
		h_cost_new = cost_ptr->hard_cost;
		delta_cost =rnewcost - rcost;    /* (4) compute the difference
                                                           between the 2 costs:
                                                           delta = f(S_1) - f(S_0) */
#if 0
		printf("anneal_on_time_room(): delta_cost = %lf\n", delta_cost);
		printf("anneal_on_time_room(): temperature = %lf\n", temperature);
#endif
		if (delta_cost < 0.0)                    
		  {                           /* (5) set S_0 = S_1 */
                                              /* The above S_1 configuration becomes the 
                                                 current S_0 configuration.  */
		    bcopy(&(classes[swap2]), &(saveclasses), sizeof(CLASS));
		    bcopy(&(classes[swap1]), &(classes[swap2]), sizeof(CLASS));
		    bcopy(&(saveclasses), &(classes[swap1]), sizeof(CLASS));
		    continue;                             
		  }
		else
		  {
		    dice = ((double) random()/INT_MAX);      /* (6) generate random number. */
		    dcost = (double) pow((double) M_E, - (double) delta_cost/temperature); 
		    if (dice < dcost) 
		      {                                      /* (7) set S_0 = S_1 */
                                                             /* The above S_1 configuration
                                                                becomes the current S_0
                                                                configuration.    */
			bcopy(&(classes[swap2]), &(saveclasses), sizeof(CLASS));
			bcopy(&(classes[swap1]), &(classes[swap2]), sizeof(CLASS));
			bcopy(&(saveclasses), &(classes[swap1]), sizeof(CLASS));
			continue;                        
		      } 
		  }
	      }
	    counter++;
	    temperature = temperature * cooling_factor;  

#if 0
	    printf("Temperature = %lf\n ", temperature); 
#endif
	  }
	cost = (double) cost_ptr->total_cost; 
#if 1
	printf("new-room-cost: %lf\n", cost_ptr->total_cost);
#endif
	free(cost_ptr);
      }
      
/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/

check_the_corresponding_classes(int accept, int swap1, int swap2)
{
  int position1 = 0, position2 = 0, i = 0, j = 0, k = 0;

  for (j = 0; j < MAXNUMDEPT ; j++)
    {
      if (classes[swap1].prefix == dept[j])
	position1 = j;
      if (classes[swap2].prefix == dept[j])
	position2 = j;
    }
  for (i = 0; i < MAXNUMBLD ; k++)
    {
      if (state_distance[position1][i] == state_distance[position2][i] == 99999)
	{
	  accept = FALSE;
	  for (k = 0; k < MAXNUMBLD ; k++)
	    {
	      if (state_distance[position1][k] == state_distance[position2][k] == 1)
		{
		  accept = TRUE;
		  break;
		}
	    }
	  if (accept)
	    break;
	}
      else
	{
	  if ((state_distance[position1][i] != 99999) && 
	      (state_distance[position2][i] != 99999))
	    accept = TRUE;
	  else
	    accept = FALSE;
	}
    }
  return(accept); 
}

/*=======================================================================*/
/*=======================================================================*/
/*=======================================================================*/

write_schedule()
{
        int    time_only = 0, i = 0, j = 0, k = 0;
#if 0
	for (i = 0; i < studentcount; i++) {
	  printf("Student_name: %s\n", students[i].name);
	  printf("Student_ID: %ld\n", students[i].studentid);
	  printf("Major: %d\n", students[i].major);
          printf("Number of classes chosen: %d\n", students[i].numb_classes_chosen);
	  printf("The student first class choices: \n");
	  
	  for(j = 0; j < students[i].numb_classes_chosen; j++){
	    printf("%d\t", students[i].first_choice[j]);
	  }
	  printf("\n===================================\n");
	}
#endif

	for (i = 0; i < roomcount; i++) {
	  for(j = 0; j < TIMESLOTS; j++) {       /* timeslots per day */
	    for( k=0; k < classcount; k++) {
	      if ((classes[k].time == j ) && (classes[k].room == i )) 
               {  /*   i<-->j  the time and space coincide. */
		 printf("Class Timeslot: %d\n",classes[k].time);
		 printf("Room number: %d\t  Room Size: %d\n",classes[k].room,rooms[classes[k].room].room_capacity);
		 if (classes[k].enrollment > rooms[classes[k].room].room_capacity)
		   printf("WARNING: OVER CAPACITY\n");
		 printf("Enrollment: %d\n",classes[k].enrollment);
		 printf("Professor number: %s\n",professors[classes[k].profnumber]);
		 printf("Current class serial number: %d   (Previous class serial number: %d)\n", classes[k].number, k);
		 printf("Class_name: %s\n", classes[k].name);
		 printf("Room(xxxx)Time(y) [xxxxy]: %d  \n\n", classes[k].troom); 
	       }
	    }
	  }
	  printf("Room: %d  has  %d  classes assigned to it.\n", i, rooms[i].nclasses);
	  printf("============= End Record of room %d ============\n", i);
        }
#if 0
	printf("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n");
	for (i= 0; i < studentcount; i++) {
	  printf("student_ID (SSN): %ld\n", students[i].studentid);
	  for (j = 0; j < students[i].numb_classes_chosen; j++) {
 printf("class_choice: %d  Prof_name: %s  Room_number: %d   Class_time: %d\n", j, 
  professors[classes[students[i].first_choice[j]].profnumber].name,
  classes[students[i].first_choice[j]].room, classes[students[i].first_choice[j]].time);
	  }
	  printf("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
	  }
#endif

	fflush(stdout);
      }

/***=======================================***/
#ifdef FOOBAR
tmpchar = classnames;
tmpint  = classnumbers;
for (i = 0; i < classcount; i++) {
  printf("Class #:%d\t\t Class Name: %s\n", *tmpint, tmpchar);
  tmpchar += STRINGLENGTH;
  tmpint++;
}
#endif				/* FOOBAR */
